#include <CapacitiveSensor.h>
#include "pitches.h"

#define speaker 13

// setez send pins si receive pins
CapacitiveSensor b1 = CapacitiveSensor(A5, A4);
CapacitiveSensor b2 = CapacitiveSensor(A3, A2);
CapacitiveSensor b3 = CapacitiveSensor(4, 5);
CapacitiveSensor b4 = CapacitiveSensor(A1, A0);
CapacitiveSensor b5 = CapacitiveSensor(8, 9);

// setez pinii pentru leduri
const int lpin1 = 2;
const int lpin2 = 3;
const int lpin3 = 6;
const int lpin4 = 7;
const int lpin5 = 10;

// setare pin pentur butonul de profesor
const int professor = 12;
int state = 0;

// initializez un counter care sa ma ajute sa
// redau in ordine melodiile pentru profesor
int count = 0;

// cele trei seturi pentru melodii ce contin informatiile necesare
// pentru redarea unei melodii (ce nota sa cante, ce clapa sa se apese,
// ce led sa se aprinda, si cat sa dureze nota)

// SET 1
int melody1[] = {
  NOTE_C4, NOTE_G3, NOTE_G3, NOTE_A3, NOTE_G3, NOTE_B3, NOTE_C4
};

int noteDurations1[] = {
    4, 8, 8, 4, 8, 4, 4,
    0 //
};

int leds1[] = {
  lpin1, lpin2, lpin2, lpin4, lpin2, lpin3, lpin1
};

CapacitiveSensor buttons1[] = {
  b1, b2, b2, b4, b2, b3, b1
};

// SET 2
int melody2[] = {
  NOTE_E4, NOTE_E4,NOTE_E4, 
  NOTE_C4, NOTE_E4,
  NOTE_G4, NOTE_G3,
  NOTE_C4, NOTE_G3,
  NOTE_E3,
  NOTE_A3, NOTE_B3,   
  NOTE_AS3, NOTE_A3,
};

int noteDurations2[] = {
  4, 4, 4,
  4, 4,
  2, 4, 2,
  4, 4,
  4,
  4, 4,  
  4, 4,
};

int leds2[] = {
  lpin4, lpin4, lpin4,
  lpin5, lpin4,
  lpin1, lpin2,
  lpin5, lpin2,
  lpin3,
  lpin2, lpin3,
  lpin1, lpin2,
};

CapacitiveSensor buttons2[] = {
  b4, b4, b4, 
  b5, b4, 
  b1, b2,
  b5, b2,
  b3,
  b2, b3,
  b1, b2, 
};

// SET 3
int melody3[] = {
  NOTE_C2, NOTE_F3, NOTE_C3, NOTE_A2, NOTE_A2,
  NOTE_C3, NOTE_F3, NOTE_C3,
  NOTE_C3, NOTE_F3, NOTE_C3, NOTE_F3,
  NOTE_AS3, NOTE_G3, NOTE_F3, NOTE_E3, NOTE_D3, NOTE_CS3,
};

int noteDurations3[] = {
  4, 4, 4, 8, 8,
  4, 4, 2,
  4, 4, 4, 4, 
  3, 8, 8, 8, 8, 8, 
  0 // adaug 0 pentru terminare
};
int leds3[] = {
  lpin4, lpin2, lpin1, lpin5, lpin5, 
  lpin1, lpin2, lpin1,
  lpin1, lpin2, lpin1, lpin2,
  lpin4, lpin5, lpin2, lpin5, lpin1, lpin2,
};

CapacitiveSensor buttons3[] = {
  b4, b2, b1, b5, b5,
  b1, b2, b1,
  b1, b2, b1, b2,
  b4, b5, b2, b5, b1, b2, 
};

// functie care asteapta pana cand o clapa este
// apasata
void keyWait(CapacitiveSensor bpin) {
  while (1) {
    long bState = bpin.capacitiveSensorRaw(200);
    if (bState > 3) {
      return;
    }
  }
}

// functie ce reda prima melodie
void Song1() {
  for (int i = 0; i < 7; i++) {
        int duration = 600 / noteDurations1[i];
        digitalWrite(leds1[i], HIGH);
        keyWait(buttons1[i]);
        tone(speaker, melody1[i], duration);
        int pause = duration * 1.50;
        delay(2 * pause);
        noTone(speaker);
        digitalWrite(leds1[i], LOW);
      }
}

// functie ce reda a doua melodie
void Song2() {
  for (int i = 0; i < 14; i++) {
        int duration = 600 / noteDurations2[i];
        digitalWrite(leds2[i], HIGH);
        keyWait(buttons2[i]);
        tone(speaker, melody2[i], duration);
        int pause = duration * 1.50;
        delay(2 * pause);
        noTone(speaker);
        digitalWrite(leds2[i], LOW);
      }
}

// functie ce reda a treia melodie
void Song3() {
  for (int i = 0; i < 18; i++) {
        int duration = 600 / noteDurations3[i];
        digitalWrite(leds3[i], HIGH);
        keyWait(buttons3[i]);
        tone(speaker, melody3[i], duration);
        int pause = duration * 1.50;
        delay(2 * pause);
        noTone(speaker);
        digitalWrite(leds3[i], LOW);
      }
}

void setup() {
  // initilizez ledurile
  pinMode(lpin1, OUTPUT);
  pinMode(lpin2, OUTPUT);
  pinMode(lpin3, OUTPUT);
  pinMode(lpin4, OUTPUT);
  pinMode(lpin5, OUTPUT);
  
  digitalWrite(lpin1, LOW);
  digitalWrite(lpin2, LOW);
  digitalWrite(lpin3, LOW);
  digitalWrite(lpin4, LOW);
  digitalWrite(lpin5, LOW);

  pinMode(professor, INPUT);
  digitalWrite(professor, HIGH);

  // pornesc comunicarea cu computerul
  Serial.begin(9600);
}

void loop() {
  // setez senzitivitatea
  long sens1 = b1.capacitiveSensorRaw(200);
  long sens2 = b2.capacitiveSensorRaw(200);
  long sens3 = b3.capacitiveSensorRaw(200);
  long sens4 = b4.capacitiveSensorRaw(200);
  long sens5 = b5.capacitiveSensorRaw(200);

  // cazurile in care una din clape este atinsa
  if (sens1 > 3) {
    tone(speaker, NOTE_C4);
    digitalWrite(lpin1, HIGH);
  }
  
  if (sens2 > 3) {
    tone(speaker, NOTE_G3);
    digitalWrite(lpin2, HIGH);
  }
  
  if (sens3 > 3) {
    tone(speaker, NOTE_B3);
    digitalWrite(lpin3, HIGH);
  }
  
  if (sens4 > 3) {
    tone(speaker, NOTE_A3);
    digitalWrite(lpin4, HIGH);
  }

  if (sens5 > 3) {
    tone(speaker, NOTE_G4);
    digitalWrite(lpin5, HIGH);
  }

 // cazul in care nicio clapa nu e atinsa
  if (sens1 < 3 && sens2 < 3 && sens3 < 3 && sens4 < 3 && sens5 < 3) {
    noTone(speaker);
    digitalWrite(lpin1, LOW);
    digitalWrite(lpin2, LOW);
    digitalWrite(lpin3, LOW);
    digitalWrite(lpin4, LOW);
    digitalWrite(lpin5, LOW);
  }

  // cazul in care este apasat butonul de profesor
  if (digitalRead(professor) == LOW) {
    if (count == 2) {
      Song3();
      count++;
    }
    if (count == 1) {
      Song2();
      count++;
    }

    if (count == 0) {
      Song1();
      count++;
    }

    // resetare counter
    if (count == 3) {
      count = 0;
    }
  }
}
